Subject: Re: bug#57639: [PATCH] Add new command 'toggle-theme'

From: Philip Kaludercic <[email-masked]>
Date: Mon, 12 Sep 2022 15:26:25 +0000

Po Lu <[email-masked]> writes:

> Lars Ingebrigtsen <[email-masked]> writes:
>
>> Philip Kaludercic <[email-masked]> writes:
>>
>>>> I thought we already had support for this under Gtk?  But I may be
>>>> misremembering.
>>>
>>> Am I reading it correctly that `style_changed_cb' in gtkutils.c would be
>>> a place to start looking for this functionality?
>>
>> Ah, yes, I think that's the one...  Po Lu probably know more about this;
>> added to the CCs.
>
> What exactly is the wanted feature?
>
> If it's automatically switching between dark and light themes

For now it is just detecting that a switch should be made.

>                                                              , then
> style_changed_cb is probably not the right place.  It's mostly vestigial
> code from when we used to update the region face along with the GTK
> stylesheet.  Instead, TRT used to be to listen for changes to the
> `gtk-application-prefer-dark-theme' property of the GtkSettings object.
>
> However, that has been superseeded by a dbus based interface in recent
> versions of GNOME.  I do not understand the details, but it seems like
> it could be implemented in Lisp:
>
>   https://flatpak.github.io/xdg-desktop-portal/#gdbus-org.freedesktop.portal.Settings

Would this have to be re-implemented for most desktop environments, or
do most of them use DBus to signal these changes?